clc
clear all
close all
%% TD21_S1-G1
% D=2.5/50;  % Height of the section
% file = 'TD21_S1-G1_01_00_001.mat';
% path_data = ['.\Data\TD21_S1-G1\'];
% path_res = ['.\Results\TD21_S1-G1\'];
% mass = 5.6817;
%% TD21_S1-G2
% D=2.5/50;  % Height of the section
% file = 'TD21_S1-G2_01_00_001.mat'; 
% path_data = ['.\Data\TD21_S1-G2\'];
% path_res = ['.\Results\TD21_S1-G2\'];
% mass = 5.6817;
%% TD21_S1-G3
% D=2.5/50;  % Height of the section
% file = 'TD21_S1-G3_01_00_003.mat';
% path_data = ['.\Data\TD21_S1-G3\'];
% path_res = ['.\Results\TD21_S1-G3\'];
% mass = 5.6817;
%% TD21_S2-G1
% D=2.5/50;  % Height of the section
% file = 'TD21_S2-G1_01_00_003.mat';
% path_data = ['.\Data\TD21_S2-G1\'];
% path_res = ['.\Results\TD21_S2-G1\'];
% mass = 5.6175;
%% TD21_S2-G2
% D=2.5/50;  % Height of the section
% file = 'TD21_S2-G2_01_00_003.mat';
% path_data = ['.\Data\TD21_S2-G2\'];
% path_res = ['.\Results\TD21_S2-G2\'];
% mass = 5.6175;
%% TD21_S2-G3 with active TMD
% D=2.5/50;  % Height of the section
% file = 'TD21_S2-G3_01_00_004.mat';
% path_data = ['.\Data\TD21_S2-G3\'];
% path_res = ['.\Results\TD21_S2-G3\'];
% mass = 5.6175;
%% TD21_S2-G3 with disabled TMD
% D=2.5/50;  % Height of the section
% file = 'TD21_S2-G3_01_00_007.mat';
% path_data = ['.\Data\TD21_S2-G3\'];
% path_res = ['.\Results\TD21_S2-G3\'];
% mass = 5.6175;
%% TD21_S3-G1
D=2.5/50;  % Height of the section
file = 'TD21_S3-G1_01_00_001.mat';
path_data = ['.\Data\TD21_S3-G1\'];
path_res = ['.\Results\TD21_S3-G1\'];
mass = 5.8076;
%% TD21_S3-G2
% D=2.5/50;  % Height of the section
% file = 'TD21_S3-G2_01_00_001.mat';
% path_data = ['.\Data\TD21_S3-G2\'];
% path_res = ['.\Results\TD21_S3-G2\'];
% mass = 5.8076;
%% TD21_S3-G3
% D=2.5/50;  % Height of the section
% file = 'TD21_S3-G3_01_00_003.mat';
% path_data = ['.\Data\TD21_S3-G3\'];
% path_res = ['.\Results\TD21_S3-G3\'];
% mass = 5.8076;
%% Import data
load([path_data file]); %Load data
U = NTNUWT.Data.ProcessedData(1).Data; %Measured mean wind velocity
u = NTNUWT.Data.ProcessedData(2).Data; %Measured displacements
FG = NTNUWT.Data.ProcessedData(4).Data; %Measured forces
Fs=str2double(NTNUWT.Data.Root.Property(5).Value{1}(1:end-3)); %Sampling frequency
t=0:1/Fs:(size(u,1)-1)/Fs; % Time vector
rhostr=num2str(strrep(NTNUWT.Data.Root.Property(10).Value{1},',','.')); %Air density
%% Asses frequency content
FGz = FG(:,3:6:end);
Fz1 = FGz(:,1) + FGz(:,2);
Fz2 = FGz(:,2) + FGz(:,3);

GFz1 = fftshift(fft(Fz1(1:end-1,1)));
GFz2 = fftshift(fft(Fz2(1:end-1,1)));
f = linspace(-1,1,length(GFz1))*Fs/2;
figure
plot(f,abs(GFz1))
hold on
plot(f,abs(GFz2))
xlim([0 20])
ylim([0 50000])
%% Design filter
bpFilt = designfilt('bandpassiir','FilterOrder',20, ...
    'HalfPowerFrequency1',10,'HalfPowerFrequency2',13, ...
    'SampleRate',Fs);

dlp = designfilt('lowpassiir','DesignMethod','butter',...
    'PassbandFrequency',0.5,'StopbandFrequency',1,'PassbandRipple',0.1,'StopbandAttenuation',60,'SampleRate',Fs); % Make butterworth filter
%fvtool(bpFilt)
%% plot vibrations

set(0,'DefaultAxesTitleFontWeight','normal');

Fz1filt = filtfilt(bpFilt,Fz1);
Fz2filt = filtfilt(bpFilt,Fz2);
maxF = ceil(max(max([Fz1filt Fz2filt]))/10)*10;
h = figure;

ax1 = subplot(3,1,1);
ax1.Position=[0.1300 0.7451 0.7750 0.25];
plot(t,U)
grid on; grid minor;
ylabel('$\mathrm{V\:\left[ms^{-1}\right]}$','Interpreter','Latex')
xlim([0 670])
ylim([0 13])
xlabel('$\mathrm{t\:[s]}$','Interpreter','Latex')
ax = gca; ax.FontSize = 16;

ax2 = subplot(3,1,2); grid on;
plot(t,Fz1filt)
ylabel('$\mathrm{\sum{F_z}\:[N]}$' ,'Interpreter','Latex')
xlabel('$\mathrm{t\:[s]}$','Interpreter','Latex')
xlim([0 670])
ylim([-1 1]*maxF)
ax = gca; ax.FontSize = 16;


ax3 = subplot(3,1,3); grid on; hold on; 
plot(t,Fz2filt)
ylabel('$\mathrm{\sum{F_z}\:[N]}$' ,'Interpreter','Latex')
xlabel('$\mathrm{t\:[s]}$','Interpreter','Latex')
xlim([0 670])
ylim([-1 1]*maxF)
ax = gca; ax.FontSize = 16;

linkaxes([ax1 ax2 ax3],'x')
h.Position=[488   342   555   700];
h.Position=[488   342   1120   840];
h.Children(3).Title.String = strrep(file(1:10), '_', ' ');
h.Children(2).Title.String = 'Upstream girder';
h.Children(1).Title.String = 'Downstream girder';
h.Children(2).YMinorGrid = 'on';
h.Children(2).XMinorGrid = 'on';
h.Children(1).YMinorGrid = 'on';
h.Children(1).XMinorGrid = 'on';
h.Name = file(1:10);

saveas(h,strcat(string(file(1:10)),'_VIV.jpg'))

