clc
clear all 
close all

% CALCULATIONS OF STROUHAL NUMBER
% St=fs*D/V

% INPUT:
% fs:   vortex shedding frequency [s^-1]
% V:    associated wind speed [ms^-1]
% D:    characteristic dimension [m]

% Rows are sections (S), and columns are gaps (G)

G=[110, 210, 310]; %[mm]
D=0.05;
fs=[12.50 12.50 12.50;
    11.49 12.20 11.76;
    12.35 12.99 11.90];
V=[4.55 4.1 4.05;
    3.35 3.3 3.15;
    3.6	3.4	3.0];
St=zeros(length(V));

for i=1:length(V) % rows
    for j=1:length(V) % columns
        St(i,j)=fs(i,j)*D/V(i,j);
    end
end

St

f1=figure; hold on; box on; 
plot(G/D/1000,St(1,:),'--bo', 'MarkerSize',14,'LineWidth',1.2)
plot(G/D/1000,St(2,:),'--ro', 'MarkerSize',14,'LineWidth',1.2)
plot(G/D/1000,St(3,:),'--o','color',[0 0.6 0.3], 'MarkerSize',14,'LineWidth',1.2)
grid on; grid minor; 
xlabel('$\mathrm{gap/depth\:[-]}$','Interpreter','Latex')
ylabel('$\mathrm{St\:[-]}$','Interpreter','Latex')
legend('S1','S2','S3')
ylim([0.10 0.3])
xlim([1.4 7])
xticks([2 4 6])
ax = gca; ax.FontSize = 16;

saveas(f1,'St.jpg')


